﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Text;
using MapApp.Model;
using System.IO;
using System.IO.IsolatedStorage;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization;
using System.Net;


namespace MapApp
{
    public class HistoryFileIsolatedStorage : HistoryFile
    {
        public HistoryFileIsolatedStorage()
        {
            HistoryFileLoader = LoadHistoryFile;
            HistoryFileSaver = SaveHistoryFile;
        }

        private List<string> LoadHistoryFile(string fileName)
        {
            IsolatedStorageFile isoStore = 
              IsolatedStorageFile.GetStore( IsolatedStorageScope.User | IsolatedStorageScope.Assembly,
              null, null );
            //string[] fileNames = isoStore.GetFileNames(APPLICATION_NAME + "/" + fileName);

            //WebClient client = new WebClient();
            //Stream stream = client.OpenRead(BASE_URL + fileName);
            //Stream stream = client.OpenRead(fileName);
            Stream stream = new IsolatedStorageFileStream(APPLICATION_NAME + "/" + fileName, FileMode.OpenOrCreate, isoStore);

            BinaryFormatter bf = new BinaryFormatter();
            List<string> result = (List<string>)bf.Deserialize(stream);
            stream.Close();
            return result;
        }

        private void SaveHistoryFile(List<string> contents, string fileName)
        {
            // Don't try to save empty history
            if (contents == null) return;
            if (contents.Count == 0) return;

            MemoryStream memoryStream = new MemoryStream();
            BinaryFormatter bf = new BinaryFormatter();
            bf.Serialize(memoryStream, contents);

            byte[] bytes = memoryStream.ToArray();
            memoryStream.Close();

            IsolatedStorageFile isoStore =
              IsolatedStorageFile.GetStore(IsolatedStorageScope.User | IsolatedStorageScope.Assembly,
              null, null);
            isoStore.CreateDirectory(APPLICATION_NAME);
            Stream stream = new IsolatedStorageFileStream(APPLICATION_NAME + "/" + fileName, FileMode.OpenOrCreate, isoStore);
            stream.Write(bytes, 0, bytes.Length);
            stream.Close();
            //string sResponse = UploadDataEx(bytes, fileName,
            //    PUT_URL, "uploadedfile", "application/octet-stream",
            //    null, null);

            //WebClient client = new WebClient();
            //client.Headers.Add("Content-Type", "multipart/form-data");
            //byte[] response = client.UploadData(PUT_URL, bytes);
            //string sResponse = Encoding.ASCII.GetString(response);
            //WebHeaderCollection responseHeaders = client.ResponseHeaders;


            //_wrapper.AddObject(BUCKET_NAME, KEY_NAME, bytes);
            //_wrapper.AddObject(BUCKET_NAME, fileName, bytes);
        }


    }
}
