using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;
using System.IO;

using System.Windows.Forms;



namespace MapApp.Ui.Controls
{
    class AppUtil
    {
        public static string tempDir = System.IO.Path.GetTempPath() + "map";
        public static FrmMain frmMain = null;  // set in Init()

        public static bool Init(FrmMain frmMain)
        {
            AppUtil.frmMain = frmMain;


            return true;
        }

        /// <summary>
        /// Writes a resource to the specified filepath.
        /// Creates destination directory if necessary.
        /// Overwrites whatever was there before.
        /// </summary>
        /// <param name="resourceName"></param>
        /// <param name="filePath"></param>
        public static void writeResourceToDisk(string resourceName, string filePath)
        {
            Dictionary<string, string> replacements = new Dictionary<string, string>();
            writeResourceToDisk(resourceName, filePath, replacements);
        }

        /// <summary>
        /// Writes a resource to the specified filepath.
        /// Creates destination directory if necessary.
        /// Overwrites whatever was there before.
        /// Does token replacement within the resource, using the string pairs in
        /// the replacements Dictionary.
        /// </summary>
        /// <param name="resourceName"></param>
        /// <param name="filePath"></param>
        public static void writeResourceToDisk(string resourceName, string filePath,
            Dictionary<string, string> replacements)
        {
            Assembly asm = (new AppUtil()).GetType().Assembly;

            //string[] resourceNames = asm.GetManifestResourceNames();

            Stream s = asm.GetManifestResourceStream(resourceName);
            // Read resource into a inbuf:
            int len = (int)s.Length;
            byte[] inbuf = new byte[len];
            s.Read(inbuf, 0, len);
            s.Close();

            string sBuf = System.Text.Encoding.UTF8.GetString(inbuf, 0, len);
            foreach (string token in replacements.Keys)
            {
                string value = "";
                replacements.TryGetValue(token, out value);
                sBuf = sBuf.Replace(token, value);
            }
            // Write the inbuf to disk:
            string dirPath = Path.GetDirectoryName(filePath);
            if (!Directory.Exists(dirPath)) Directory.CreateDirectory(dirPath);
            FileStream fs = File.Create(filePath, len);
            //fs.Write(inbuf, 0, len);
            byte[] outBuf = System.Text.Encoding.UTF8.GetBytes(sBuf);
            fs.Write(outBuf, 0, outBuf.Length);
            fs.Close();
        }


    }
}
