using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MapApp.Ui.Controls
{
    public partial class FrmAbout : AppFormBase
    {
        public FrmAbout()
        {
            InitializeComponent();
            txtFullVersionString.Text = "Version " + Version;
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            this.Hide();
        }


        /// <summary>
        /// Returns Published Version if this assembly has been click-once
        /// deployed, otherwise returns assembly version.
        /// </summary>
        public string Version
        {
            get
            {
                System.Reflection.Assembly _assemblyInfo =
                  System.Reflection.Assembly.GetExecutingAssembly();
                string result = string.Empty;
                //if running the deployed application, you can get the version
                // from the ApplicationDeployment information. If you try
                // to access this when you are running in Visual Studio, it will not work.
                if (System.Deployment.Application.ApplicationDeployment.IsNetworkDeployed)
                {
                    result =
                      System.Deployment.Application.ApplicationDeployment.CurrentDeployment.CurrentVersion.ToString();
                }
                else
                {
                    if (_assemblyInfo != null)
                    {
                        result = _assemblyInfo.GetName().Version.ToString();
                    }
                }
                return result;
            }
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            //string target = e.Link.LinkData as string;
            System.Diagnostics.Process.Start((sender as LinkLabel).Text);
        }
    }
}